require 'uu/os/application/use_case_context_middleware'
require 'uu/os/cmd/command_context'
require 'uu/os/cmd/command_callback_context'

module UU
  module OS
    module CMD
      class CommandContextMiddleware < UU::OS::Application::UseCaseContextMiddleware

        def initialize(app)
          super(app)
        end

        # @private
        def get_context(request)
          data = prepare_data(request)

          if data.has_key?(:result)
            return UU::OS::CMD::CommandCallbackContext.new(data)
          else
            return UU::OS::CMD::CommandContext.new(data)
          end

        end

        # @private
        def prepare_data(request)
         data = super(request)
         ctx = data[:uuCtx]
          if !ctx.nil?
            data[:result] = ctx[:result] if ctx.has_key?(:result)
            data[:callback] = ctx[:callback]
          end
          return data
        end
      end

    end
  end
end
